program GRAVITATION;
{*****************************************************************************
*    THREE BODY PROBLEM by Michal Krizek, MU CSAV, Zitna 25, Praha, 1992     *
*****************************************************************************}
uses graph,crt;
const pocet=19;
      scale=1;n=8;{pocet pohybovych rovnic}
      d: array [0..pocet,0..20] of real =(
{h, sm, sj , si,sr,sb,um, ux, uy,uxv,uvy,ub,uc,nm, nx,ny,nvx,nvy,nb,nc,jj}
(1.5,1000,280,205,10,14,10, 92,  0, 0, 3.4, 2,10,10,234, 0, 0, 1.9, 1,11,2999),
(1, 810,320,222, 7,14,10,-250, 0, 0,  -1, 9,11, 0,1000,50,-5,  0, 12,12,1999),
(1,1000,180,222,33,11, 1, 50,  0, 0, 4.5, 9,11, 1, -50,0, 0,-6.18,12,12,1999),
(1,1000,135,222,10,14,4.7,150, 0,0,2.5,1,14,0,400,-60,-1,-0.3,4,7,9999),
(0.9,405,84,50,6,14,30,464,100,-0.089,-0.6,1,11,20,450,-100,-0.1,0.8,4,12,2800)
,(0.3,2000,320,222,7,14,0,80,0,0,5,8,14,0,-80,0,0,-5,8,12,30000),
(2,1000,320,222,33, 4, 0, 92,  0, 0, 3.4, 1,12, 0, 234,0 ,0 ,  2, 1,14,9999),
(0.9,1000,149,222, 5,14,5,-149, 0,0,-2.6, 9,11, 0,120,0, 0,2,12,12,29999),
(0.5,1000,270,222,2,14,0.06,-200,0,0,-2.25,1,11,0,295,0,0,1.62,4,12,30000),
(2,   0,320,222,0 , 0,1000,-200,0,0,-0.5, 4,12,500,100, 0, 0,  1, 9,11,9999),
(0.5,1000,320,222,11,14,0, 0, -50,6,  0,  5,13, 300,234,0, 0,  2, 1,14,999),(
0.5,1000,230,222,3,14,100,415,-60,-1.8,-1.8,1,11,100,400,-60,-1.8,1.2,4,12,1999
),(1,1000,320,222,12,14,330,200, 0, 0,   2, 0,11, 1, 216,0, 0,   7, 0, 7,9999),
(0.3,2000,320,222,7,14,0,80,0,0,5,8,14,0,40,69.28203,-4.330127,2.5,4,12,30000),
(0.2,10000,320,222,6,9,33.4567901253,100,0,0,10,6,14,0,90,0,0,9,5,13,6000),
(0.6,2000,80,79, 9, 14,25.8,80,0,0,-5, 1,11,   0,782.3,0,-3,0.4,4,8,4300),
(2,   0,320,222,0.5, 0,1000,-200,0,0, 1,  4,12,1000,200,0, 0, -1, 9,11,9999),
(2,   0,320,222,0 , 0,1000,-200,0,0,-0.61,4,12, 500,100,0, 0,1.22,9,11,9999),
(2,   0,320,222,0.5, 0,800,-200,0,0,  1,  4,12, 800,200,0, 0, -1, 9,11,9999),
(2,   0,320,222,0, 0, 100,150,0,0,1.52,4,12, 500,-30,0, 0,-0.304,9,11,9999));
{nm-hmota, nx,ny-pocatecni poloha, nvx,nvy-pocatecni rychlost, nb,nc-barvy}

     s: array [0..3,-1..pocet] of string[75] =((
'S T I S K N I   N E J A K E   P I S M E N O',
'Gravitacni vliv dvou velkych planet vzajemne na sebe',
'Hyperbolicka a elipticka draha',
'I. a II. kosmicka rychlost (kruznice, parabola)',
'Jupiter a jeho gravitacni vliv na pohyb komety',
'Kolize',
'Lagrangeovy body',
'Mars, Phobos a Deimos',
'Nerelativisticke staceni perihelia',
'Orbity Neptuna a Pluta',
'Pohyb dvojhvezdy (obecny pripad)',
'Draha sondy k povrchu Slunce s vyuzitim pritazlivosti Jupitera',
'Roztrzeni dvojplanety',
'Slunce, Zeme a Mesic',
'Trojane - planetky v stabilnim Lagrangeove bodu na draze Jupitera',
'Unik satelitu z nestabilniho Lagrangeova bodu mezi Zemi a Mesicem',
'Vznik periodicke komety',
'Pohyb dvojhvezdy (specialni pripad I)',
'Pohyb dvojhvezdy (specialni pripad II)',
'Pohyb dvojhvezdy (specialni pripad III)',
'Pohyb dvojhvezdy (specialni pripad IV)'
),(
'   DRUECKEN  SIE  IRGENDEINEN  BUCHSTABEN',
'Gegenseitige Beeinflussung  zweier grosser Planeten durch Gravitation',
'Hyperbolische und elliptische Bahnkurve',
'I. und II. kosmische Geschwindigkeit (Kreis, Parabel)',
'Der Einfluss der Gravitation von Jupiter auf eine Kometenbewegung',
'Die Kollisionen',
'Lagrange-Punkt',
'Mars, Phobos und Deimos',
'Nichtrelativistische Drehung des Perihels',
'Die Bahnen der Planeten Neptun und Pluto',
'Bewegung eines Doppelsternes (allgemeiner Fall)',
'Raketenbahn zur Sonne, welche die Gravitation des Jupiter benutzt',
'Trennung eines Doppelplaneten',
'Sonne, Erde und Mond',
'Bahnkurve eines Asteroids an einem stabilen Lagrange-Punkt der Jupiter-Bahn',
'Fluchtbewegung von einem instabilen Lagrange-Punkt zwischen Erde und Mond',
'Entstehung eines periodischen Kometen',
'Bewegung eines Doppelsternes (Spezialfall I)',
'Bewegung eines Doppelsternes (Spezialfall II)',
'Bewegung eines Doppelsternes (Spezialfall III)',
'Bewegung eines Doppelsternes (Spezialfall IV)'
),(
'      P R E S S   A N Y   L E T T E R',
'Mutual gravitational influence of two large planets',
'Hyperbolic and elliptical trajectories',
'First and second cosmic speed (circle, parabola)',
'Gravitational influence of Jupiter on the motion of a comet',
'Collisions',
'Lagrange points',
'Mars, Phobos and Deimos',
'Nonrelativistic perihelion twisting',
'Orbits of Neptune and Pluto',
'Motion of a double star (general case)',
'Trajectory of a rocket to the Sun utilizing the gravitation of Jupiter',
'Division of a double planet system',
'Sun, Earth and Moon',
'Asteroid trajectory in a stable Lagrange point on the Jupiter orbit',
'Shuttle escape from an unstable Lagrange point between the Earth and Moon',
'Birth of a periodic comet',
'Motion of a double star (special case I)',
'Motion of a double star (special case II)',
'Motion of a double star (special case III)',
'Motion of a double star (special case IV)'
),(
'   APPUYEZ  SUR  UNE  LETTRE  QUELCONQUE',
'Influence gravitationnelle mutuelle entre deux grandes planetes',
'Trajectoire hyperbolique et elliptique',
'Premiere et seconde vitesse cosmique (cercle, parabole)',
'Influence gravitationnelle de Jupiter sur le mouvement d une comete',
'Collisions',
'Points Lagrange',
'Mars, Phobos et Deimos',
'Deplacement perihelie non-relativiste',
'Orbites des Neptune et Pluton',
'Mouvement d une etoile double (cas general)',
'Trajectoire d une fusee vers le Soleil utilisant la gravitation de Jupiter',
'Division d une planete double',
'Soleil, Terre et Lune',
'Petites planetes en le point Lagrange stable situe sur l orbit de Jupiter',
'Fuite du point Lagrange instable situe entre la Terre et la Lune',
'Naissance d une comete periodique',
'Mouvement d une etoile double (cas particulier I)',
'Mouvement d une etoile double (cas particulier II)',
'Mouvement d une etoile double (cas particulier III)',
'Mouvement d une etoile double (cas particulier IV)'));
      g: array[0..pocet,0..4] of integer =(
(8,-10,-26,-39,44),(-12,-24,-28,0,0),(-17,32,0,0,0),(23,-25,0,0,0),
(0,0,0,0,0),(0,0,0,0,0),(0,0,0,0,0),(-16,-20,21,-24,-31),
(0,0,0,0,0),(13,-24,27,-28,0),(-3,35,-38,42,46),(6,-9,0,0,0),
(12,17,-19,0,0),(-7,-29,42,-54,0),(-1,-26,-55,60,-62),(-16,0,0,0,0),(
13,-24,-27,30,-31),(13,-24,-27,30,-31),(13,-24,-27,30,-31),(13,-24,-27,30,-31)
);{cislo znamena pozici ceskeho hacku(+) nebo carky(-)}
     gg: array[0..pocet,0..3] of integer =(
(160,0,0,0),(0,0,0,0),(106,0,0,0),(57,165,0,0),
(0,0,0,0),(0,0,0,0),(0,0,0,0),(-2,-14,-18,0),
(0,0,0,0),(12,-17,-37,-39),(14,-22,0,0),(11,120,0,0),
(0,0,0,0),(113,-50,57,0),(-38,0,0,0),(12,120,-25,0),
(12,-17,0,0),(12,-17,0,0),(12,-17,0,0),(12,-17,0,0));

type vector = array [1..n] of real;
label 1,2,3,4,5,6;
var i,j,jj,k,si,sj,sr,sb,uj,uuj,ui,uui,nj,nnj,ni,nni,ub,uc,nb,nc,code,e,w,po,
    graphdriver,graphmode: integer;
    h,h2,h6,sm,um,nm: real;
    z,y,k1,k2,k3,k4: vector;
    chr: char;
procedure planet(j,i,b: integer);
    begin setcolor(b);rectangle(j,i,j+1,i+1) end;
function odm23(x: real): real;
    begin odm23:=x*sqrt(x) end;
function f(i: integer;y: vector): real;
    begin case i of
    1:f:=y[2];
    2:f:=-sm*y[1]/odm23(sqr(y[1])+sqr(y[3]))
         +nm*(y[5]-y[1])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3]));
    3:f:=y[4];
    4:f:=-sm*y[3]/odm23(sqr(y[1])+sqr(y[3]))
         +nm*(y[7]-y[3])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3]));
    5:f:=y[6];
    6:f:=-sm*y[5]/odm23(sqr(y[5])+sqr(y[7]))
         +um*(y[1]-y[5])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3]));
    7:f:=y[8];
    8:f:=-sm*y[7]/odm23(sqr(y[5])+sqr(y[7]))
         +um*(y[3]-y[7])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3])) end end;

procedure v(x,y: integer);
begin putpixel(x+1,y-1,w);putpixel(x+2,y-1,w);putpixel(x+4,y-1,w);
putpixel(x+5,y-1,w);putpixel(x+2,y,w);putpixel(x+3,y,w);putpixel(x+4,y,w) end;

procedure l(x,y: integer);
begin putpixel(x+4,y-1,w);putpixel(x+5,y-1,w);
putpixel(x+3,y,w);putpixel(x+4,y,w) end;

procedure ll(x,y: integer);
begin putpixel(x+1,y-1,w);putpixel(x+2,y-1,w);putpixel(x+1,y,w) end;

procedure lll(x,y: integer);
begin putpixel(x+3,y-1,w);putpixel(x+4,y-1,w);
putpixel(x+4,y,w);putpixel(x+5,y,w) end;

procedure aaa;
const a:array[1..6,1..41] of integer=(
( 1, 2, 3, 4, 8, 9,10,11,12,17,18,19,20,24,29,32,33,34,37,38,39,40,41,45,46,
 47,48,52,53,54,55,56,59,60,61,65,66,67,68,72,77),
( 0, 5, 8,13,16,21,24,29,33,39,44,49,54,60,64,69,72,73,77, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
( 0, 8,13,16,21,24,29,33,39,44,49,54,60,64,69,72,74,77, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
( 0, 3, 4, 5, 8, 9,10,11,12,16,17,18,19,20,21,24,29,33,39,44,45,46,47,48,49,
 54,60,64,69,72,75,77, 0, 0, 0, 0, 0, 0, 0, 0, 0),
( 0, 5, 8,12,16,21,25,28,33,39,44,49,54,60,64,69,72,76,77, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
( 1, 2, 3, 4, 8,13,16,21,26,27,32,33,34,39,44,49,54,59,60,61,65,66,67,68,72,
 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0));
b:array[1..6] of integer=(41,19,18,32,19,26);
var GraphDriver,GraphMode,ErrorCode: integer;
    MaxX,MaxY,MaxColor: word;
    OldExitProc: Pointer;

    procedure Initialize;
    var InGraphicsMode: boolean;
    PathToDriver: string;
       begin DirectVideo:=False;OldExitProc:=ExitProc;PathToDriver:= '';
       repeat GraphDriver:=IBM8514;GraphMode:=IBM8514Hi;GraphDriver:=Detect;
       InitGraph(GraphDriver,GraphMode,PathToDriver);ErrorCode:=GraphResult;
       if ErrorCode <> grOK then begin
       Writeln('Graphics error: ',GraphErrorMsg(ErrorCode));
       if ErrorCode=grFileNotFound then begin
       Writeln('Enter full path to BGI driver or type <Ctrl-Break> to quit:');
       Readln(PathToDriver); Writeln end else Halt(1) end;until ErrorCode=grOK;
       Randomize;MaxColor:=GetMaxColor;MaxX:=GetMaxX;MaxY:=GetMaxY;
       end;{ Initialize }
    procedure PutPixelPlay;
    const Seed=1962;NumPts=2000;
    var I,X,Y,Color: word;
       XMax,YMax,ii,jj: integer;
       ViewInfo: ViewPortType;
       begin setfillstyle(solidfill,4);bar(86,103,546,202);
       setfillstyle(solidfill,12);bar(96,110,536,195);setcolor(14);
       for ii:=1 to 6 do for jj:=1 to b[ii] do
       outtextxy(120+5*a[ii,jj],130+5*ii,'o');
       setcolor(8);outtextxy(16,320,
'This program is published in: Michal Krizek, O problemu tri teles, Rozhledy');
outtextxy(16,336,
'matematicko-fyzikalni 70 (1992), 109-110, Mathematical Institute, Prague 1.'
);w:=8;
v(320,320);l(328,320);v(336,320);l(432,320);v(472,320);l(480,320);v(504,320);
l(152,336);l(176,336);
       GetViewSettings(ViewInfo);with ViewInfo do
       begin XMax:=x2-x1-1;YMax:=y2-y1-50 end;
       while not KeyPressed do begin RandSeed:=Seed;I:=0;
       while (not KeyPressed) and (I<NumPts) do begin Inc(I);
       PutPixel(Random(XMax)+1,Random(YMax)+1,Random(MaxColor)+1) end;
       RandSeed:=Seed;I:=0;
       while (not KeyPressed) and (I<NumPts) do begin Inc(I);X:=Random(XMax)+1;
       Y:=Random(YMax)+1;Color:=GetPixel(X,Y);if Color=Random(MaxColor)+1 then
       PutPixel(X,Y,0) end end end;{ PutPixelPlay }

begin Initialize;PutPixelPlay end {aaa};

                        (*   M   A   I   N   *)

begin e:=0;graphdriver:=detect;initgraph(graphdriver,graphmode,' ');
{Do poslednich uvozovek ' ' napis cestu do adresare s BGI soubory,
                       napr.,....,graphmode,'C:\TP\BGI');                }
setgraphmode(graphmode);
1: po:=0;SetBkColor(1);ClearDevice;w:=13;setcolor(13);outtextxy(80,20,
'C - cesky ,   D - deutsch ,   E - English ,   F - francais');v(112,20);
l(511,28);
  SetFillStyle(SolidFill,12);bar(4,34,636,346);
4: SetFillStyle(SolidFill,15);bar(8,37,632,342);
SetColor(0);
for i:=0 to pocet do begin jj:=42+i*15;
outtextxy(16,jj,char(i+71)+' '+s[e,i]);
if e=0 then begin w:=0;for j:=0 to 4 do if g[i,j]=0 then goto 5 else
if g[i,j]>0 then v(24+8*g[i,j],jj) else l(24-8*g[i,j],jj)
end;
if e=3 then begin w:=0;for j:=0 to 3 do if gg[i,j]=0 then goto 5 else
if gg[i,j]>100 then lll(24+8*(gg[i,j]-100),jj) else
if gg[i,j]>0 then ll(24+8*gg[i,j],jj) else l(24-8*gg[i,j],jj)
end;
5:end;
SetFillStyle(SolidFill,1);bar(100,0,540,11);k:=9;
repeat delay(300);k:=20-k;
setcolor(k);outtextxy(140,4,s[e,-1]);
if e=0 then begin w:=k;v(284,2);l(348,2);l(396,2) end;
until keypressed;
3: chr:=ReadKey;k:=ord(chr);
if k=27 then goto 2 else if k>90 then k:=k-32;
if k=65 then begin aaa;chr:=ReadKey;goto 1 end else
if k=66 then begin SetBkColor(3);ClearDevice;setcolor(14);
outtextxy(120,60,'B - zastaveni demonstrace  G, H,...,Z');w:=14;l(216,60);
outtextxy(120,100,'B - Abbrechen der Demonstration  G, H,...,Z');
outtextxy(120,140,'B - pause during the demonstration  G, H,...,Z');
outtextxy(120,180,'B - pause pendant la demonstration  G, H,...,Z');
outtextxy(120,220,'- pomalu, langsam, slowly, lentement');
outtextxy(120,260,'+ rychle, schnell, quickly, vite');
chr:=ReadKey;goto 1 end;
if (k>66) and (k<71) then begin e:=k-67;goto 4 end;
if (k<70) or (k>90) then
begin sound(100);delay(100);nosound;goto 3 end else
k:=k-71;
h:=d[k,0];h2:=h/2;h6:=h/6;
sm:=d[k,1];sj:=round(d[k,2]);si:=round(d[k,3]);sr:=round(d[k,4]);
sb:=round(d[k,5]);
um:=d[k,6];y[1]:=d[k,7];y[3]:=d[k,8];y[2]:=d[k,9];y[4]:=d[k,10];
ub:=round(d[k,11]);uc:=round(d[k,12]);
nm:=d[k,13];y[5]:=d[k,14];y[7]:=d[k,15];y[6]:=d[k,16];y[8]:=d[k,17];
nb:=round(d[k,18]);nc:=round(d[k,19]);jj:=round(d[k,20]);
setbkcolor(0);cleardevice;
setcolor(9);outtextxy(8,1,s[e,k]);
if e=0 then begin w:=9;for j:=0 to 4 do if g[k,j]=0 then goto 6 else
if g[k,j]>0 then v(8*g[k,j],1) else l(-8*g[k,j],1) end;
if e=3 then begin w:=9;for j:=0 to 3 do if gg[k,j]=0 then goto 6 else
if gg[k,j]>100 then lll(8*(gg[k,j]-100),1) else
if gg[k,j]>0 then ll(8*gg[k,j],1) else l(-8*gg[k,j],1)
end;
6: if sm>0 then begin setcolor(sb);setfillstyle(solidfill,sb);
                      circle(sj,si,sr);floodfill(sj,si,sb) end;
uuj:=sj+round(y[1]);uui:=si-round(y[3]/scale);
nnj:=sj+round(y[5]);nni:=si-round(y[7]/scale);
for j:=1 to jj do begin
  uj:=sj+round(y[1]);ui:=si-round(y[3]/scale);
  nj:=sj+round(y[5]);ni:=si-round(y[7]/scale);
planet(uuj,uui,0);planet(uj,ui,uc);
if y[2]>0 then putpixel(uuj,uui,ub) else putpixel(uuj+1,uui,ub);
planet(nnj,nni,0);planet(nj,ni,nc);
if y[6]>0 then putpixel(nnj,nni,nb) else putpixel(nnj+1,nni,nb);
if keypressed then begin chr:=ReadKey;
if (chr='b') or (chr='B') then chr:=ReadKey else
if chr='-' then po:=200 else if chr='+' then po:=0 else
goto 1 end;delay(po);
uuj:=uj;uui:=ui;nnj:=nj;nni:=ni;
{METODA RUNGOVA-KUTTOVA}
for i:=1 to n do k1[i]:=f(i,y);
for i:=1 to n do z[i]:=y[i]+h2*k1[i];
for i:=1 to n do k2[i]:=f(i,z);
for i:=1 to n do z[i]:=y[i]+h2*k2[i];
for i:=1 to n do k3[i]:=f(i,z);
for i:=1 to n do z[i]:=y[i]+h*k3[i];
for i:=1 to n do k4[i]:=f(i,z);
for i:=1 to n do y[i]:=y[i]+h6*(k1[i]+2*k2[i]+2*k3[i]+k4[i])
end;goto 1;2: closegraph end.
