program GRAVITY3;{THREE BODY PROBLEM}
uses graph,crt;
const h=0.001  ;                                 {casovy diskretizacni parametr}
      sm=0{1000} ;sj=320 ;si=175;sr=0{33}            ;sb=14;        {Slunce-fixovano}
      um=1000{1}    ;ux=-50{92}  ;uy=0  ;uvx=0   ;uvy=-2.23605{3.4} ;ub=4 ; uc=12;            {Uran}
      nm=1000{1}    ;nx=50{234} ;ny=0  ;nvx=0   ;nvy=2.23605{2}   ;nb=1 ; nc=11;         {Neptun}
{nm-hmota, nx,ny-pocatecni poloha, nvx,nvy-pocatecni rychlost, nb,nc-barvy}
      h2=h/2;h6=h/6;scale=1;
      n=8;{pocet pohybovych rovnic}
type vector = array [1..n] of real;
label 1,2;
var i,j,uj,uuj,ui,uui,nj,nnj,ni,nni,graphdriver,graphmode: integer;
    z,y,k1,k2,k3,k4: vector;
    cislo,nic: string[6];
function odm23(x: real): real;
    begin odm23:=x*sqrt(x) end;
function f(i: integer;y: vector): real;
    begin case i of
    1:f:=y[2];
    2:f:=-sm*y[1]/odm23(sqr(y[1])+sqr(y[3]))
         +nm*(y[5]-y[1])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3]));
    3:f:=y[4];
    4:f:=-sm*y[3]/odm23(sqr(y[1])+sqr(y[3]))
         +nm*(y[7]-y[3])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3]));
    5:f:=y[6];
    6:f:=-sm*y[5]/odm23(sqr(y[5])+sqr(y[7]))
         +um*(y[1]-y[5])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3]));
    7:f:=y[8];
    8:f:=-sm*y[7]/odm23(sqr(y[5])+sqr(y[7]))
         +um*(y[3]-y[7])/odm23(sqr(y[5]-y[1])+sqr(y[7]-y[3])) end end;

begin y[1]:=ux;y[3]:=uy;y[2]:=uvx;y[4]:=uvy;
      y[5]:=nx;y[7]:=ny;y[6]:=nvx;y[8]:=nvy;
      j:=0;nic:=chr(219)+chr(219)+chr(219)+chr(219)+chr(219)+chr(219);
graphdriver:=detect;initgraph(graphdriver,graphmode,' ');
setgraphmode(graphmode);
setcolor(ub);outtextxy(0,0,'v=');
setcolor(nb);outtextxy(0,15,'v=');
setcolor(sb);
for i:=1 to sr do begin circle(sj,si,i);circle(sj,si-1,i) end;
uuj:=sj+round(y[1]);uui:=si-round(y[3]/scale);
nnj:=sj+round(y[5]);nni:=si-round(y[7]/scale);
1:uj:=sj+round(y[1]);ui:=si-round(y[3]/scale);
  nj:=sj+round(y[5]);ni:=si-round(y[7]/scale);
putpixel(uj,ui,uc);putpixel(uj+1,ui,uc);
putpixel(uj,ui+1,uc);putpixel(uj+1,ui+1,uc);
putpixel(uuj,uui,0);putpixel(uuj+1,uui,0);
putpixel(uuj,uui+1,0);putpixel(uuj+1,uui+1,0);
if y[2]>0 then putpixel(uuj,uui,ub) else putpixel(uuj+1,uui,ub);
putpixel(nj,ni,nc);putpixel(nj+1,ni,nc);
putpixel(nj,ni+1,nc);putpixel(nj+1,ni+1,nc);
putpixel(nnj,nni,0);putpixel(nnj+1,nni,0);
putpixel(nnj,nni+1,0);putpixel(nnj+1,nni+1,0);
if y[6]>0 then putpixel(nnj,nni,nb) else putpixel(nnj+1,nni,nb);
if keypressed then begin closegraph;goto 2 end;
uuj:=uj;uui:=ui;nnj:=nj;nni:=ni;
{delay(10);                                           regulace rychlosti teles}
{METODA RUNGOVA-KUTTOVA}
for i:=1 to n do k1[i]:=f(i,y);
for i:=1 to n do z[i]:=y[i]+h2*k1[i];
for i:=1 to n do k2[i]:=f(i,z);
for i:=1 to n do z[i]:=y[i]+h2*k2[i];
for i:=1 to n do k3[i]:=f(i,z);
for i:=1 to n do z[i]:=y[i]+h*k3[i];
for i:=1 to n do k4[i]:=f(i,z);
for i:=1 to n do y[i]:=y[i]+h6*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);
j:=j+1;if j=3 then begin
str(round(10*sqrt(sqr(y[2])+sqr(y[4]))),cislo);
setcolor(0); outtextxy(16,0,nic);
setcolor(ub);outtextxy(16,0,cislo) end;
if j=6 then begin j:=0;
str(round(10*sqrt(sqr(y[6])+sqr(y[8]))),cislo);
setcolor(0); outtextxy(16,15,nic);
setcolor(nb);outtextxy(16,15,cislo) end;
goto 1;2:end.
