program GRAVITY5; uses graph,crt;       {Three body problem in 3D}
const h=0.5;h2=h/2;h6=h/6;scale=1.3456;n=12;j1=320;i1=50;i2=220;
             (*  V S T U P N I   D A T A  *)
{m=1000 ;m2=20; p2x=148; p2y=0; p2z=0; v2x=0;  v2y=2.45; v2z= 1.5;
        m3=20; p3x=153; p3y=0; p3z=0; v3x=0;  v3y=2.65; v3z=-1.5;}
{m=1000 ;m2=14; p2x=-100; p2y=0;   p2z=30;  v2x=0;  v2y=-2.9;  v2z=0;
         m3=14; p3x=0; p3y=150; p3z=0;  v3x=-2.5;  v3y=0; v3z=0;}
m=300 ;m2=-150; p2x=0;  p2y=0;  p2z=100;  v2x=0;  v2y=1.62;  v2z=0;
       m3=-150; p3x=100; p3y=0;  p3z=0;   v3x=0;  v3y=-1.62;  v3z=0;
type vector = array [1..n] of real;
var i,j,graphdriver,graphmode: integer;
    a: real;
    z,y,k1,k2,k3,k4: vector;
function d(x,y,z: real): real;
    begin a:=sqr(x)+sqr(y)+sqr(z);d:=a*sqrt(a) end;
function f(i: integer;y: vector): real;
begin case i of
1:f:=y[2];
2:f:=-m*y[1]/d(y[1],y[3],y[5])+m3*(y[7]-y[1])/d(y[7]-y[1],y[9]-y[3],y[11]-y[5]);
3:f:=y[4];
4:f:=-m*y[3]/d(y[1],y[3],y[5])+m3*(y[9]-y[3])/d(y[7]-y[1],y[9]-y[3],y[11]-y[5]);
5:f:=y[6];
6:f:=-m*y[5]/d(y[1],y[3],y[5])+m3*(y[11]-y[5])/d(y[7]-y[1],y[9]-y[3],y[11]-y[5]);
7:f:=y[8];
8:f:=-m*y[7]/d(y[7],y[9],y[11])+m2*(y[1]-y[7])/d(y[7]-y[1],y[9]-y[3],y[11]-y[5]);
9:f:=y[10];
10:f:=-m*y[9]/d(y[7],y[9],y[11])+m2*(y[3]-y[9])/d(y[7]-y[1],y[9]-y[3],y[11]-y[5]);
11:f:=y[12];
12:f:=-m*y[11]/d(y[7],y[9],y[11])+m2*(y[5]-y[11])/d(y[7]-y[1],y[9]-y[3],y[11]-y[5])
end end;
            (*   H L A V N I   P R O G R A M   *)
begin y[1]:=p2x;y[3]:=p2y; y[5]:=p2z;y[2]:=v2x; y[4]:=v2y; y[6]:=v2z;
      y[7]:=p3x;y[9]:=p3y;y[11]:=p3z;y[8]:=v3x;y[10]:=v3y;y[12]:=v3z;
graphdriver:=detect;initgraph(graphdriver,graphmode,' ');
setgraphmode(graphmode);setbkcolor(0);
if m>0 then begin setcolor(1);setfillstyle(solidfill,1);
   circle(j1,i1,45);floodfill(j1,i1,1);circle(j1,i2,45);floodfill(j1,i2,1) end;
setcolor(7);outtextxy(0,i1,'Rovina xz');outtextxy(0,i2,'Rovina xy');
repeat
j:=j1+round(y[1]);putpixel(j,i1-round(y[5]/scale),11);
putpixel(j,i2-round(y[3]/scale),11);
j:=j1+round(y[7]);putpixel(j,i1-round(y[11]/scale),12);
putpixel(j,i2-round(y[9]/scale),12);
       (*  M E T O D A   R U N G O V A - K U T T O V A  *)
  for i:=1 to n do begin k1[i]:=f(i,y);z[i]:=y[i]+h2*k1[i] end;
  for i:=1 to n do k2[i]:=f(i,z);
  for i:=1 to n do z[i]:=y[i]+h2*k2[i];
  for i:=1 to n do k3[i]:=f(i,z);
  for i:=1 to n do z[i]:=y[i]+h*k3[i];
  for i:=1 to n do k4[i]:=f(i,z);
  for i:=1 to n do y[i]:=y[i]+h6*(k1[i]+2*k2[i]+2*k3[i]+k4[i])
until keypressed end.