program GRAVITYX; uses graph,crt;
const h=0.9;h2=h/2;h6=h/6;scale=1.3456;n=8;j1=250;i1=275;
(* vstupn data *)

m1=1000; m2=4; p2x=150; p2y=0;   v2x=0;  v2y=2.5;   //drha komety
         m3=0; p3x=400; p3y=-60; v3x=-1; v3y=-0.3;

//m1=2000; m2=0; p2x=80; p2y=0;   v2x=0;  v2y=-5;   //kruh a parabola
//         m3=0; p3x=-80; p3y=0; v3x=0; v3y=5*1.414;

//m1=1000; m2=0; p2x=250; p2y=0;   v2x=0;  v2y=-1;   //elipsa a hyperbola
//         m3=0; p3x=1000; p3y=50; v3x=-5; v3y=0;

//m1=0; m2=800; p2x=-30; p2y=0;   v2x=0;  v2y=1;   //speciln ppad problmu dvou tles 1
//         m3=800; p3x=370; p3y=0; v3x=0; v3y=-1;

//m1=0; m2=1000; p2x=-30; p2y=0;   v2x=0;  v2y=-1;   //speciln ppad problmu dvou tles 2
//         m3=1000; p3x=370; p3y=0; v3x=0; v3y=1;

//m1=0; m2=1000; p2x=20; p2y=0;   v2x=0;  v2y=-0.61;   //speciln ppad problmu dvou tles 3
//         m3=500; p3x=320; p3y=0; v3x=0; v3y=1.22;

//m1=0; m2=1000; p2x=20; p2y=0;   v2x=0;  v2y=-0.5;   //speciln ppad problmu dvou tles 4
//         m3=500; p3x=320; p3y=0; v3x=0; v3y=1;

//m1=1000; m2=10; p2x=92; p2y=0;   v2x=0;  v2y=3/2.0;   //vzjemn gravitan vliv dvou velkch planet
//         m3=10; p3x=150; p3y=0; v3x=0; v3y=2.5;

//m1=1000; m2=324; p2x=200; p2y=0;   v2x=0;  v2y=2;   //obh dvojplanety kolem Slunce
//         m3=4; p3x=216; p3y=0; v3x=0; v3y=7;

//m1=1000; m2=100; p2x=415; p2y=-60;   v2x=-1.8;  v2y=-1.8;   //roztren dvojplanety v silnm gravitanm poli
//         m3=90; p3x=400; p3y=-60; v3x=-1.8; v3y=1.2;

//m1=1000; m2=5; p2x=-149; p2y=0;   v2x=0;  v2y=-2.6;   //nerelativistick sten perihelia planety
//         m3=0.1; p3x=120; p3y=0; v3x=0; v3y=2;

//m1=1000; m2=265; p2x=234; p2y=0;   v2x=0;  v2y=2;   //gravitan ping pong
//         m3=0; p3x=0; p3y=-50; v3x=6; v3y=0;



type vector = array [1..n] of real;
var i,j2,jj2,i2,ii2,j3,jj3,i3,ii3,graphdriver,
    graphmode: integer;
    z,y,k1,k2,k3,k4: vector;

procedure planet(j,i,b:integer);
    begin setcolor(b);rectangle(j,i,j+1,i+1) end;

function d(x,y: real): real;
    begin d:=(sqr(x)+sqr(y))*sqrt(sqr(x)+sqr(y)) end;

function f(i: integer;y: vector): real;
begin case i of
1:f:=y[2];
2:f:=-m1*y[1]/d(y[1],y[3])+m3*(y[5]-y[1])/d(y[5]-y[1],y[7]-y[3]);
3:f:=y[4];
4:f:=-m1*y[3]/d(y[1],y[3])+m3*(y[7]-y[3])/d(y[5]-y[1],y[7]-y[3]);
5:f:=y[6];
6:f:=-m1*y[5]/d(y[5],y[7])+m2*(y[1]-y[5])/d(y[5]-y[1],y[7]-y[3]);
7:f:=y[8];
8:f:=-m1*y[7]/d(y[5],y[7])+m2*(y[3]-y[7])/d(y[5]-y[1],y[7]-y[3]);
end end;



            (*   H L A V N I   P R O G R A M   *)


begin y[1]:=p2x;y[3]:=p2y;y[2]:=v2x;y[4]:=v2y;
      y[5]:=p3x;y[7]:=p3y;y[6]:=v3x;y[8]:=v3y;
graphdriver:=detect;initgraph(graphdriver,graphmode,' ');
setgraphmode(graphmode);setbkcolor(0);
if m1>0 then begin setcolor(14);setfillstyle(solidfill,14);
   circle(j1,i1,9);floodfill(j1,i1,14) end;

jj2:=j1+round(y[1]);ii2:=i1-round(y[3]/scale);
jj3:=j1+round(y[5]);ii3:=i1-round(y[7]/scale);
repeat;
  j2:=j1+round(y[1]);i2:=i1-round(y[3]/scale);
  j3:=j1+round(y[5]);i3:=i1-round(y[7]/scale);
  planet(j2,i2,11);planet(jj2,ii2,0);
  if y[2]>0 then putpixel(jj2,ii2,1) else
                 putpixel(jj2+1,ii2,1);

  planet(j3,i3,12);planet(jj3,ii3,0);
  if y[6]>0 then putpixel(jj3,ii3,4) else
                 putpixel(jj3+1,ii3,4);

jj2:=j2;ii2:=i2;jj3:=j3;ii3:=i3;

       (*  M E T O D A   R U N G O V A - K U T T O V A  *)
  for i:=1 to n do begin k1[i]:=f(i,y);z[i]:=y[i]+h2*k1[i] end;
  for i:=1 to n do k2[i]:=f(i,z);
  for i:=1 to n do z[i]:=y[i]+h2*k2[i];
  for i:=1 to n do k3[i]:=f(i,z);
  for i:=1 to n do z[i]:=y[i]+h*k3[i];
  for i:=1 to n do k4[i]:=f(i,z);
  for i:=1 to n do y[i]:=y[i]+h6*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);


delay(3);

until keypressed end.